# coding: utf-8

"""
    VMware Aria Automation Assembler / CMX Service API

    When using Kubernetes integration, deploy and manage Kubernetes clusters and namespaces. The APIs that list collections of resources also support OData like implementation. Below query params can be used across CMX entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/cmx/api/resources/tags?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/cmx/api/resources/tags?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/cmx/api/resources/tags?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /cmx/api/resources/tags?$filter=startswith(name, 'K8S')   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ServiceDocumentDescription(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'description': 'str',
        'document_indexing_options': 'list[str]',
        'name': 'str',
        'property_descriptions': 'dict(str, Cmxapiresourcesk8szonesDocumentDescriptionPropertyDescriptions)',
        'serialized_state_size_limit': 'int',
        'service_capabilities': 'list[str]',
        'service_request_routes': 'dict(str, list[object])',
        'user_interface_resource_path': 'str',
        'version_retention_floor': 'int',
        'version_retention_limit': 'int'
    }

    attribute_map = {
        'description': 'description',
        'document_indexing_options': 'documentIndexingOptions',
        'name': 'name',
        'property_descriptions': 'propertyDescriptions',
        'serialized_state_size_limit': 'serializedStateSizeLimit',
        'service_capabilities': 'serviceCapabilities',
        'service_request_routes': 'serviceRequestRoutes',
        'user_interface_resource_path': 'userInterfaceResourcePath',
        'version_retention_floor': 'versionRetentionFloor',
        'version_retention_limit': 'versionRetentionLimit'
    }

    def __init__(self, description=None, document_indexing_options=None, name=None, property_descriptions=None, serialized_state_size_limit=None, service_capabilities=None, service_request_routes=None, user_interface_resource_path=None, version_retention_floor=None, version_retention_limit=None):  # noqa: E501
        """ServiceDocumentDescription - a model defined in Swagger"""  # noqa: E501
        self._description = None
        self._document_indexing_options = None
        self._name = None
        self._property_descriptions = None
        self._serialized_state_size_limit = None
        self._service_capabilities = None
        self._service_request_routes = None
        self._user_interface_resource_path = None
        self._version_retention_floor = None
        self._version_retention_limit = None
        self.discriminator = None
        if description is not None:
            self.description = description
        if document_indexing_options is not None:
            self.document_indexing_options = document_indexing_options
        if name is not None:
            self.name = name
        if property_descriptions is not None:
            self.property_descriptions = property_descriptions
        if serialized_state_size_limit is not None:
            self.serialized_state_size_limit = serialized_state_size_limit
        if service_capabilities is not None:
            self.service_capabilities = service_capabilities
        if service_request_routes is not None:
            self.service_request_routes = service_request_routes
        if user_interface_resource_path is not None:
            self.user_interface_resource_path = user_interface_resource_path
        if version_retention_floor is not None:
            self.version_retention_floor = version_retention_floor
        if version_retention_limit is not None:
            self.version_retention_limit = version_retention_limit

    @property
    def description(self):
        """Gets the description of this ServiceDocumentDescription.  # noqa: E501


        :return: The description of this ServiceDocumentDescription.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ServiceDocumentDescription.


        :param description: The description of this ServiceDocumentDescription.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def document_indexing_options(self):
        """Gets the document_indexing_options of this ServiceDocumentDescription.  # noqa: E501


        :return: The document_indexing_options of this ServiceDocumentDescription.  # noqa: E501
        :rtype: list[str]
        """
        return self._document_indexing_options

    @document_indexing_options.setter
    def document_indexing_options(self, document_indexing_options):
        """Sets the document_indexing_options of this ServiceDocumentDescription.


        :param document_indexing_options: The document_indexing_options of this ServiceDocumentDescription.  # noqa: E501
        :type: list[str]
        """
        allowed_values = ["INDEX_METADATA"]  # noqa: E501
        if not set(document_indexing_options).issubset(set(allowed_values)):
            raise ValueError(
                "Invalid values for `document_indexing_options` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(document_indexing_options) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._document_indexing_options = document_indexing_options

    @property
    def name(self):
        """Gets the name of this ServiceDocumentDescription.  # noqa: E501


        :return: The name of this ServiceDocumentDescription.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ServiceDocumentDescription.


        :param name: The name of this ServiceDocumentDescription.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def property_descriptions(self):
        """Gets the property_descriptions of this ServiceDocumentDescription.  # noqa: E501


        :return: The property_descriptions of this ServiceDocumentDescription.  # noqa: E501
        :rtype: dict(str, Cmxapiresourcesk8szonesDocumentDescriptionPropertyDescriptions)
        """
        return self._property_descriptions

    @property_descriptions.setter
    def property_descriptions(self, property_descriptions):
        """Sets the property_descriptions of this ServiceDocumentDescription.


        :param property_descriptions: The property_descriptions of this ServiceDocumentDescription.  # noqa: E501
        :type: dict(str, Cmxapiresourcesk8szonesDocumentDescriptionPropertyDescriptions)
        """

        self._property_descriptions = property_descriptions

    @property
    def serialized_state_size_limit(self):
        """Gets the serialized_state_size_limit of this ServiceDocumentDescription.  # noqa: E501


        :return: The serialized_state_size_limit of this ServiceDocumentDescription.  # noqa: E501
        :rtype: int
        """
        return self._serialized_state_size_limit

    @serialized_state_size_limit.setter
    def serialized_state_size_limit(self, serialized_state_size_limit):
        """Sets the serialized_state_size_limit of this ServiceDocumentDescription.


        :param serialized_state_size_limit: The serialized_state_size_limit of this ServiceDocumentDescription.  # noqa: E501
        :type: int
        """

        self._serialized_state_size_limit = serialized_state_size_limit

    @property
    def service_capabilities(self):
        """Gets the service_capabilities of this ServiceDocumentDescription.  # noqa: E501


        :return: The service_capabilities of this ServiceDocumentDescription.  # noqa: E501
        :rtype: list[str]
        """
        return self._service_capabilities

    @service_capabilities.setter
    def service_capabilities(self, service_capabilities):
        """Sets the service_capabilities of this ServiceDocumentDescription.


        :param service_capabilities: The service_capabilities of this ServiceDocumentDescription.  # noqa: E501
        :type: list[str]
        """
        allowed_values = ["INSTRUMENTATION", "PERIODIC_MAINTENANCE", "PERSISTENCE", "REPLICATION", "OWNER_SELECTION", "STRICT_UPDATE_CHECKING", "HTML_USER_INTERFACE", "CONCURRENT_UPDATE_HANDLING", "CONCURRENT_GET_HANDLING", "IDEMPOTENT_POST", "ON_DEMAND_LOAD", "IMMUTABLE", "LIFO_QUEUE", "URI_NAMESPACE_OWNER", "CORE", "UTILITY", "FACTORY", "FACTORY_ITEM", "DOCUMENT_OWNER", "TRANSACTION_PENDING", "STATELESS", "NONE"]  # noqa: E501
        if not set(service_capabilities).issubset(set(allowed_values)):
            raise ValueError(
                "Invalid values for `service_capabilities` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(service_capabilities) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._service_capabilities = service_capabilities

    @property
    def service_request_routes(self):
        """Gets the service_request_routes of this ServiceDocumentDescription.  # noqa: E501


        :return: The service_request_routes of this ServiceDocumentDescription.  # noqa: E501
        :rtype: dict(str, list[object])
        """
        return self._service_request_routes

    @service_request_routes.setter
    def service_request_routes(self, service_request_routes):
        """Sets the service_request_routes of this ServiceDocumentDescription.


        :param service_request_routes: The service_request_routes of this ServiceDocumentDescription.  # noqa: E501
        :type: dict(str, list[object])
        """

        self._service_request_routes = service_request_routes

    @property
    def user_interface_resource_path(self):
        """Gets the user_interface_resource_path of this ServiceDocumentDescription.  # noqa: E501


        :return: The user_interface_resource_path of this ServiceDocumentDescription.  # noqa: E501
        :rtype: str
        """
        return self._user_interface_resource_path

    @user_interface_resource_path.setter
    def user_interface_resource_path(self, user_interface_resource_path):
        """Sets the user_interface_resource_path of this ServiceDocumentDescription.


        :param user_interface_resource_path: The user_interface_resource_path of this ServiceDocumentDescription.  # noqa: E501
        :type: str
        """

        self._user_interface_resource_path = user_interface_resource_path

    @property
    def version_retention_floor(self):
        """Gets the version_retention_floor of this ServiceDocumentDescription.  # noqa: E501


        :return: The version_retention_floor of this ServiceDocumentDescription.  # noqa: E501
        :rtype: int
        """
        return self._version_retention_floor

    @version_retention_floor.setter
    def version_retention_floor(self, version_retention_floor):
        """Sets the version_retention_floor of this ServiceDocumentDescription.


        :param version_retention_floor: The version_retention_floor of this ServiceDocumentDescription.  # noqa: E501
        :type: int
        """

        self._version_retention_floor = version_retention_floor

    @property
    def version_retention_limit(self):
        """Gets the version_retention_limit of this ServiceDocumentDescription.  # noqa: E501


        :return: The version_retention_limit of this ServiceDocumentDescription.  # noqa: E501
        :rtype: int
        """
        return self._version_retention_limit

    @version_retention_limit.setter
    def version_retention_limit(self, version_retention_limit):
        """Sets the version_retention_limit of this ServiceDocumentDescription.


        :param version_retention_limit: The version_retention_limit of this ServiceDocumentDescription.  # noqa: E501
        :type: int
        """

        self._version_retention_limit = version_retention_limit

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ServiceDocumentDescription, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ServiceDocumentDescription):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
